# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define reltag %{nil}
%global namedversion %{version}%{?reltag}
%global Name GMetrics

Name:           gmetrics
Version:        0.3
Release:        1%{?reltag}%{?dist}
Epoch:          0
Summary:        Provides size and complexity metrics for Groovy source code
Group:          Development/Libraries
License:        ASL 2.0
URL:            http://gmetrics.sourceforge.net/
# svn export https://gmetrics.svn.sourceforge.net/svnroot/gmetrics/tags/GMetrics-0.3 gmetrics-0.3 && tar cjf gmetrics-0.3.tar.bz2 gmetrics-0.3
# Exported revision 148.
Source0:        gmetrics-0.3.tar.bz2
Source1:        gmetrics-settings.xml
Source2:        gmetrics-jpp-depmap.xml
Provides:       %{Name} = %{epoch}:%{version}-%{release}
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
Requires:       ant >= 0:1.6.5
Requires:       log4j >= 0:1.2.13
Requires:       groovy16 >= 0:1.6.9
%if 0
Requires:       codenarc >= 0:0.9
%endif
BuildRequires:  ant >= 0:1.6.5
BuildRequires:  log4j >= 0:1.2.13
BuildRequires:  groovy16 >= 0:1.6.9
# XXX: this is a circular dependency
%if 0
BuildRequires:  codenarc >= 0:0.9
%endif
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-release
BuildRequires:  gmaven >= 0:1.2
BuildRequires:  gmaven-runtime-1.6
BuildRequires:  gmaven-runtime-1.7
BuildRequires:  maven2-plugin-install
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
The GMetrics project provides calculation and reporting of size and
complexity metrics for Groovy source code.

%package javadoc
Group:          Documentation
Summary:        Javadoc for %{name}
Requires:       jpackage-utils

%description javadoc
Javadoc for %{name}.

%prep
%setup -q -n gmetrics-%{namedversion}

%{__cp} -p %{SOURCE1} maven2-settings.xml

%{__sed} -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
%{__sed} -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
%{__sed} -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
%{__sed} -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
%{__sed} -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

%{__mkdir} external_repo
%{__ln_s} %{_javadir} external_repo/JPP

%build
export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=$(pwd)/m2_repo/repository
export MAVEN_OPTS="-Djava.awt.headless=true"
%{_bindir}/mvn-jpp \
        -e \
        -s ${M2SETTINGS} \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.test.skip=true \
        -Dmaven.test.failure.ignore=true \
        package javadoc:aggregate

%install
rm -rf %{buildroot}

# jars
mkdir -p %{buildroot}%{_javadir}
cp -p target/%{Name}-%{namedversion}.jar %{buildroot}%{_javadir}/%{Name}-%{namedversion}.jar
(cd %{buildroot}%{_javadir} && for jar in *-%{namedversion}*; do ln -s ${jar} `echo ${jar} | sed "s|-%{namedversion}||g"`; done)

# poms
mkdir -p %{buildroot}%{_datadir}/maven2/poms
cp -p pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-%{Name}.pom
%add_to_maven_depmap org.gmetrics GMetrics %{namedversion} JPP %{Name}

# javadoc
mkdir -p %{buildroot}%{_javadocdir}/%{Name}-%{namedversion}
cp -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{Name}-%{namedversion}
ln -s %{Name}-%{namedversion} %{buildroot}%{_javadocdir}/%{Name}

%clean
rm -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%doc CHANGELOG.txt LICENSE.txt NOTICE.txt README.txt
%{_javadir}*/%{Name}-%{namedversion}.jar
%{_javadir}*/%{Name}.jar
%{_datadir}/maven2/poms/JPP-%{Name}.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{Name}-%{namedversion}
%{_javadocdir}/%{Name}

%changelog
* Mon May 16 2011 David Walluck <dwalluck@redhat.com> 0:0.3-1
- release
